from tkinter import *
from CalcRho_cat import *

def CalcAlpha( X, K, NPerson, NItems ):
    """
      Calculation of coefficient alpha

    """
    coeff_a = 1
    for i in range(NPerson):
        for j in range(NItems):
            if (X[i][j] < 1) or (X[i][j] > K):
                coeff_a = -1
                print('X[{0}]]...{1}'.format(i+1, X[i]))
                break

    if coeff_a > 0.0:
        sum = []
        for i in range(NItems):
            sum.append(0.0)
        gsum = 0.0
        for i in range(NPerson):
            for j in range(NItems):
                sum[j] += X[i][j]
                gsum += X[i][j]
        mean = []
        for j in range(NItems):
            mean.append(sum[j] / NPerson)
        gmean = gsum / NPerson
        ssum = []
        for j in range(NItems):
            ssum.append(0.0)
        gssum = 0.0
        for i in range(NPerson):
            jsum = 0.0
            for j in range(NItems):
                ssum[j] += (X[i][j] - mean[j]) ** 2
                jsum += X[i][j]
            gssum += (jsum - gmean) ** 2

        SgmSjj = 0.0
        for j in range(NItems):
            SgmSjj += ssum[j] / NPerson
        gSjj = gssum / NPerson
        coeff_a = (1.0 - (SgmSjj / gSjj)) * NItems / (NItems - 1)        

    return coeff_a
            
   
def EstDistriRho_cat( params ):
    """
        Estimation of the posterior distribution of Rho_cat

    """
    NCat = params['NCat']
    NItems = params['NItems']
    StartPos = params['StartPos']
    StopPos = params['StopPos']
    LSamplesID = params['LSamplesID']
    Llmbd = params['Llmbd']
    Lmu = params['Lmu']
    Lpsi = params['Lpsi']
    LC = params['LC']

    title_str = 'Estimation...from {0} to {1}'.format(StartPos, StopPos)
    root = Tk()
    root.title(title_str)
    c = Canvas(root, width = 400, height = 150, background = '#000000')
    c.pack()

    est_distri = []
    for i in range(StartPos, StopPos + 1):
        c.create_rectangle(0, 0, 401, 151, outline = '#000000', fill = '#000000')
        c.create_text(200, 75, text = 'Step {} started.'.format(i), font = ('', 15), fill = '#ffffff')
        c.update()
        
        ipos = LSamplesID[i][0]
        calc_rhos = CalcRhoPreRhoYYP( NCat, NItems, Lmu[ipos], Llmbd[ipos], Lpsi[ipos], LC[ipos] )
        est_distri.append(calc_rhos.GetRhoPre())

    root.destroy()

    return est_distri
        
        
                          



